--myfont = Font.load("/default.ttf");
--Font.setPixelSizes(myfont,18)

skipDelay = 1;

white   = Color.new(255,255,255);
black   = Color.new(0,0,0);
gray    = Color.new(82,82,82);

vndsPath        = "/vnds/";
gameName        = "Saya";
vndsSystemPath  = vndsPath .. "SYSTEM/"
vndsSavePath    = vndsPath .. "SAVES/"
gamePath        = vndsPath .. gameName .. "/";


TS = {  w = 400,
        h = 240};
BS = {  w = 320,
        h = 240};

Scr = { w = 800,
        h = 600};

textBoxArray ={
    wlimit = 35, --width limit of text
    "","","","","","","","","","","","","","","",""
};

function execOnBothBuffers(infunc)

end;

function fileToTable(file, outTable)
    local i = 1;
    for line in io.lines(file) do
        outTable[i] = line;
        i = i + 1;
    end
end;

oldpad = Controls.read();

function makeWordList (input)   --split input string into a table of a bunch of separate words
    local i = 1;
    local wordlist = {};
    for word in input:gmatch("%S+") do
        wordlist[i] = word;
        i = i+1;
     end
     return wordlist;
end;

function shiftTableDown(inputTable, num)
    for i = 1, num, 1 do
        table.remove(inputTable, #inputTable);
        table.insert(inputTable,1,"");
    end
end;

function shiftTableUp(inputTable, num)
    for i = 1, num, 1 do
        table.remove(inputTable, 1);
        table.insert(inputTable,#inputTable+1,"");
    end
end;

function writeTextBoxArray (inputarr, strwrite)       -- takes a string containing "\n" newlines and splites and writes it into the linearray.
    local formatted = textWrap(strwrite, inputarr.wlimit,"", "  ");

    sto = 0;    --count the number of lines that will be written to the linearray.  Tells how far to shift the linearray to accomadate new text.
    for line in formatted:gmatch("[^\r\n]+") do
        sto = sto+1;
    end
    shiftTableUp(inputarr,sto);

    k = 1;
    for line in formatted:gmatch("[^\r\n]+") do
        inputarr[k+#inputarr-sto] = line;
        k = k+1;
    end
end;

function printTextBoxArray (inputarr, scr)      --writes the linearray on screen
    local Q = math.floor(TS.h/#inputarr);
    for i = 1, #inputarr, 1 do
        if (inputarr[i] ~= nil) and (inputarr[i] ~= "") then
            doublePrint(0, Q*(i-1), inputarr[i], white, scr);
        end;
    end;
end;

function OneshotPrint(my_func)
	my_func()
	Screen.flip()
	Screen.refresh()
	my_func()
end

function clearArray (inputarr)      --clears the linearray
    for i = 1, #inputarr, 1 do
        inputarr[i] = "";
    end;
end;

function textWrap(str, limit, indent, indent1)  --takes a string and a specified with and makes a new string with newlines of a specified width limite when the width of a single line is larger than the limit
  indent = indent or ""
  indent1 = indent1 or indent
  limit = limit or 72
  local here = 1-#indent1
  return indent1..str:gsub("(%s+)()(%S+)()",
                          function(sp, st, word, fi)
                            if fi-here > limit then
                              here = st - #indent
                              return "\n"..indent..word
                            end
                          end)
end

function delay(num)
    for i = 1, num, 1 do
        Screen.waitVblankStart();
    end
end;


function doubleDraw(x, y, filename, scr)
    local tempimage = Screen.loadImage(filename);

    Screen.flip();
    Screen.drawImage(x,y,tempimage,scr);
    Screen.refresh();
    Screen.drawImage(x,y,tempimage,scr);

    Screen.freeImage(tempimage)
end;

function doublePrint(x, y, text, color, scr)
     Screen.flip();
     Screen.debugPrint(x, y, text, color, scr)
     Screen.refresh();
     Screen.debugPrint(x, y, text, color, scr)
end;

function doubleClearScreen(scr)   --fill entire screen with a color
    Screen.flip();
    Screen.clear(scr)
    Screen.refresh();
    Screen.clear(scr)
end;

function doubleFillRect(x1,x2,y1,y2,color,scr)   --fill entire screen with a color
    Screen.flip();
    Screen.fillRect(x1, x2, y1, y2, color, scr)
    Screen.refresh();
    Screen.fillRect(x1, x2, y1, y2, color, scr)
end;

--Screen.fillRect(0, 280, 0, 14, black, TOP_SCREEN)

function writeFileWithVar(filename, var)
    local fileStream = io.open(filename,FCREATE)
    io.write(fileStream,0,var,#var)
    io.close(fileStream)
end;

function strIsNumber(testers)
    if tonumber(testers) ~= nil then
       return 1;
    else
        return 0;
    end;
end;

function choice(choiceLine)
    doublePrint(0, 0, choiceLine, black, TOP_SCREEN)
    delay(300);
    output = System.startKeyboard("")
    return tonumber(output);
end;


function handleCurrentLine ()  --takes in currentline of game script and acts on it.
    local pauseExecute = 0
    while (pauseExecute == 0) do    --handling a textline triggers pausing and kicks back to to the main loop in order to allow user to read
        local currentline = indexedscript[i];
        local wordlist = makeWordList(currentline);
        if (wordlist[1] == "bgload") then
            doubleClearScreen(TOP_SCREEN);
            doubleDraw (40, 0, (gamePath .. "/background/" .. wordlist[2]),TOP_SCREEN);

         elseif (wordlist[1] == "setimg") then
            local x = 0; local y = 0;
            if(#wordlist == 4) then
                local x = wordlist[3]; local y = wordlist[4];
            end;
            doubleDraw (x, y, (gamePath .. "/foreground/" .. wordlist[2]),TOP_SCREEN);

         elseif (wordlist[1] == "text") then
            doubleClearScreen(BOTTOM_SCREEN)
            if  (wordlist[2] == "~") then
                clearArray(textBoxArray);
                doubleClearScreen(BOTTOM_SCREEN);
            elseif (wordlist[2] == "!") then
                clearArray(textBoxArray);
                doubleClearScreen(BOTTOM_SCREEN);
                pauseExecute = 1;
            elseif (  wordlist[2]:sub(1,1) == "@"    ) then
                writeTextBoxArray(textBoxArray, currentline:gsub("text @",""));
            else
                writeTextBoxArray(textBoxArray, currentline:gsub("text ",""));
                pauseExecute = 1;
            end;
            printTextBoxArray(textBoxArray, BOTTOM_SCREEN);

         elseif (wordlist[1] == "cleartext") then
            clearArray(textBoxArray);
            doubleClearScreen(BOTTOM_SCREEN);

        elseif (wordlist[1] == "delay") then
            if (skipDelay ~= 1) then
                delay (wordlist[2]);
            end;

        elseif (wordlist[1] == "goto") then
            lookfor = wordlist[2];
            for q = 1, #indexedscript, 1 do
                if (string.find(indexedscript[q], ("label " .. lookfor)    ) ) then
                    i = q;
                end;
            end

        elseif (wordlist[1] == "setvar") then
            local LHS   = wordlist[2];
            local OP    = wordlist[3];
            local RHS   = wordlist[4];

            if (OP == "=") then
                if ( strIsNumber(RHS) == 1 ) then
                    variables[LHS] = RHS;
                else
                    variables[LHS] = variables[RHS];
                end;

            elseif (OP == "+") then
                if ( strIsNumber(RHS) == 1 ) then
                    variables[LHS] =  math.floor(variables[LHS] + RHS);
                else
                    variables[LHS] =  math.floor(variables[LHS] + variables[RHS]);
                end;

            elseif (OP == "-") then
                if ( strIsNumber(RHS) == 1 ) then
                    variables[LHS] =  math.floor(variables[LHS] - RHS);
                else
                    variables[LHS] =  math.floor(variables[LHS] - variables[RHS]);
                end;

            end;

        elseif (wordlist[1] == "gsetvar") then
            local LHS   = wordlist[2];
            local OP    = wordlist[3];
            local RHS   = wordlist[4];

            if (OP == "=") then
                if ( strIsNumber(RHS) == 1 ) then
                    globalvariables[LHS] = RHS;
                else
                    globalvariables[LHS] = globalvariables[RHS];
                end;

            elseif (OP == "+") then
                if ( strIsNumber(RHS) == 1 ) then
                    globalvariables[LHS] =  math.floor(globalvariables[LHS] + RHS);
                else
                    globalvariables[LHS] =  math.floor(globalvariables[LHS] + globalvariables[RHS]);
                end;

            elseif (OP == "-") then
                if ( strIsNumber(RHS) == 1 ) then
                    globalvariables[LHS] =  math.floor(globalvariables[LHS] - RHS);
                else
                    globalvariables[LHS] =  math.floor(globalvariables[LHS] - globalvariables[RHS]);
                end;

            end;

        elseif (wordlist[1] == "if") then
            ;--I have no idea what I'm doing.

        elseif (wordlist[1] == "choice") then
            choice(currentline)
            ;--I have no idea what I'm doing.

        elseif (wordlist[1] == "jump") then
            clearArray(textBoxArray);
            doubleClearScreen(BOTTOM_SCREEN);

            clearArray(indexedscript);
            indexedscript = {};
            currentScriptFile =  (gamePath .. "/script/" .. wordlist[2])
            fileToTable( currentScriptFile,indexedscript );
            i = 1;
        end;


    i = i + 1;
    end;
end;

function countEntriesInTable(inTable)
    local count = 0
    for key,value in pairs(inTable) do
        count = count +1;
    end
    return count
end;

function ezioAppend(instream, input)
    io.write(instream,io.size(instream),tostring(input),#tostring(input))
end;

function savestate(filename)
    System.createDirectory(vndsSavePath)
    local fileStream = io.open(vndsSavePath .. gameName  .. ".SAV",FCREATE)

    ezioAppend(fileStream,gameName  .. "\n");
    ezioAppend(fileStream,currentScriptFile  .. "\n");
    ezioAppend(fileStream,i  .. "\n")

    ezioAppend(fileStream,"VARIABLES"  .. "\n")
    ezioAppend(fileStream, countEntriesInTable(variables)  .. "\n")
    for key,value in pairs(variables) do
        ezioAppend(fileStream,key .. "=" .. value .. "\n")
    end

    ezioAppend(fileStream,"GLOBALVARIABLES"  .. "\n")
    ezioAppend(fileStream, countEntriesInTable(globalvariables)  .. "\n")
    for key,value in pairs(globalvariables) do
        ezioAppend(fileStream,key .. "=" .. value .. "\n")
    end

    System.takeScreenshot(vndsSavePath .. gameName .. ".bmp",false)
    io.close(fileStream)
end;

function doubleDrawScreencapToScreen(filename)
    cap = Screen.loadImage(filename)

    Screen.flip();
    Screen.drawPartialImage(0,0,40,TS.h,BS.w,BS.h, cap,BOTTOM_SCREEN)
    Screen.drawPartialImage(0,0,0,0,TS.w,TS.h, cap,TOP_SCREEN)
    Screen.refresh();
    Screen.drawPartialImage(0,0,40,TS.h,BS.w,BS.h, cap,BOTTOM_SCREEN)
    Screen.drawPartialImage(0,0,0,0,TS.w,TS.h, cap,TOP_SCREEN)

    Screen.freeImage(cap)
end;

function loadstate(filename)
    local tempTable = {};
    fileToTable(vndsSavePath .. gameName .. ".SAV",tempTable);
    gameName = tempTable[1];
    currentScriptFile = tempTable[2];
    i = tonumber(tempTable[3]);

    clearArray(textBoxArray);
    doubleClearScreen(BOTTOM_SCREEN);

    doubleDrawScreencapToScreen(vndsSavePath .. gameName .. ".bmp")
end;

--test = Sound.openOgg("/blood.ogg", true)
--Sound.init()
--Sound.play(test,NO_LOOP,0x09)

Screen.refresh();
doubleDraw(0,0,vndsSystemPath .. "Loading.png",TOP_SCREEN);
indexedscript = {};
currentScriptFile = gamePath .. "/script/s02.txt"
fileToTable(currentScriptFile,indexedscript);
doubleDraw(0,0,vndsSystemPath .. "/DoneLoading.png",TOP_SCREEN);

variables       = {};
globalvariables = {};

i = 1;
while true do
    Screen.waitVblankStart();
	pad = Controls.read();

	if (Controls.check(pad,KEY_A)) and not (Controls.check(oldpad,KEY_A)) then
        if (i < #indexedscript) then  --prevent crashes by not trying to read further than table's length
            handleCurrentLine ();
        end
	elseif (Controls.check(pad,KEY_X)) and not (Controls.check(oldpad,KEY_X)) then  --debug keys
        doubleDraw(0,0,gamePath .. "/foreground/fumi01.png",TOP_SCREEN);
	elseif (Controls.check(pad,KEY_B)) then
        handleCurrentLine ()
        i = i + 1;
	elseif (Controls.check(pad,KEY_Y)) and not (Controls.check(oldpad,KEY_Y)) then
        doubleFillRect(0, 280, 0, 14, black, TOP_SCREEN)
        doublePrint(0, 0, "KILOBYTES_IN_USE: " .. (math.floor(collectgarbage("count")*1024)), white, TOP_SCREEN)
	elseif (Controls.check(pad,KEY_START )) and not (Controls.check(oldpad,KEY_START )) then
        System.exit()
	elseif (Controls.check(pad,KEY_L )) and not (Controls.check(oldpad,KEY_L )) then
        loadstate("Saya01.sav");
    elseif (Controls.check(pad,KEY_R)) and not (Controls.check(oldpad,KEY_R )) then
        savestate("Saya01.sav");
    elseif (Controls.check(pad,KEY_SELECT )) and not (Controls.check(oldpad,KEY_SELECT  )) then
        ;--Sound.play(test,NO_LOOP,0x09)
	end;

	oldpad = pad
	collectgarbage()
end;
